function [x, H] = metro_veach(image, x0, s, N, H)

xk = x0;
pk = lookup(image, xk);
for k = 1:N
    xp = xk + randn(2,1) * s;
    pp = lookup(image,xp);
    a = pp / pk;
    if a < 1, H(round(xk(1)), round(xk(2))) = H(round(xk(1)), round(xk(2))) + (1 - a); end;
    if a > 0, H(round(xp(1)), round(xp(2))) = H(round(xp(1)), round(xp(2))) + min(1, a); end;
    if rand() < pp / pk;
        xk = xp;
        pk = pp;
    end
end
x = xk;

function p = lookup(image, x)

i = round(x(1));
j = round(x(2));

if i < 1 || i > size(image,1) || j < 1 || j > size(image,2)
    p = 0;
else
    p = double(image(i,j));
end